/*
 * main.c
 *
 *      Author: GSI
 */

#include <usbstk5515.h>
#include <AIC_func.h>
#include <stdio.h>
#include <Dsplib.h>

#define NUM_SEC 4
#define BIQ_COEFF 6

//useful for timing routine!
#define TCR0 		*((ioport volatile Uint16 *)0x1810)
#define TIMCNT1_0 	*((ioport volatile Uint16 *)0x1814)
#define TIME_START  0x8001
#define TIME_STOP   0x8000


Uint16 start_time, end_time, delta_time;

Int16 biq[NUM_SEC * BIQ_COEFF];

Int16 delay_DF1_buff  [NUM_SEC * 4];

Int32 biq_32[NUM_SEC * BIQ_COEFF] = {
	    949,      852,      949,    32767,   -51865,    21848,
		8891,    -7384,     8891,    32767,   -48865,    26496,
		20766,   -25092,    20766,    32767,   -46583,    30256,
		27144,   -35298,    27144,    32767,   -45920,    32143};

Int16 IIR_DF1(Int16 input, Int16 *biq, Int16 *delay_buff, Uint16 Num_Sec);

void main(void) {
	Uint16 i;
	Int16 input, notUsed, output;
	USBSTK5515_init();

	//TODO: Convert each of the filter coeff. from 32-bit Q15 to 16-bit Q14.
	for(i=0; i<NUM_SEC; i++)
	{
		biq[(i*BIQ_COEFF)  ] = ;		//b0
		biq[(i*BIQ_COEFF)+1] = ;		//b1
		biq[(i*BIQ_COEFF)+2] = ;		//b2

		biq[(i*BIQ_COEFF)+3] = ;		//a0  -- this one is actually ignored.
		biq[(i*BIQ_COEFF)+4] = ;		//a1
		biq[(i*BIQ_COEFF)+5] = ;		//a2
	}

	for(i=0; i<NUM_SEC*4; i++)
		delay_DF1_buff[i] = 0; //Initialize the registers to zero

	AIC_init();
	while(1) {
		AIC_read2(&input, &notUsed);
		output = IIR_DF1(input, biq, delay_DF1_buff, NUM_SEC);
		AIC_write2(output, notUsed);
	}
}
Int16 IIR_DF1(Int16 input, Int16 *biq, Int16 *delay_buff, Uint16 Num_Sec) {
	Uint16 j;
	Int16 x;
	Int32 Acc;

	// Each stage will have "x" as its input.  For the first stage x is the
	// actual input, for each stage after that it is the output of the last stage.
	x = input;
	
	// Now go through each stage.
	for(j=0; j<NUM_SEC; j++) {

		Acc = ; // TODO: This will take the 16-bit Q15 values from the input
				// and Z-1 blocks and multiply them by the 16-bit Q14 coeffs
				// to get a 32-bit Q29.

		Acc = ; // TODO Convert to a 16-bit Q15 with rounding and saturation.

		//TODO update the various delay blocks.  BE VERY CAREFUL OF THE ORDER!
		delay_buff[(j*NUM_SEC)+1]	= ;
		delay_buff[(j*NUM_SEC)  ]	= ;
		// The other two delay blocks go here.

		x = (Int16)Acc;
	}
	return x;
}
